<?php

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	
	$host = $_POST['hostname']; 
	$databaseName = $_POST['mod_dbname']; 
	$user = $_POST['username']; 
	$pass = $_POST['password']; 

	try {
	// Crear una nueva conexión PDO
		$pdo = new PDO("mysql:host=$host;dbname=$databaseName", $user, $pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

	//Buscar base de datos a ejecutar 
		// $query0 = "SHOW DATABASES LIKE 'vpsfmsac_%'";
		// $databases = $pdo->query($query0)->fetchAll(PDO::FETCH_COLUMN);

		// if (empty($databases)) {
		// 	echo 'No se encontraron base de datos con el prefijo vpsfmsac_';
		// 	exit;
		// }

		// foreach ($databases as $databaseName) {
			
			// if (substr($databaseName, -10) !== '_seguridad') {

				// 0. Alterar la tabla prodserv con el campo nProSrvPeso
				$add_column = "ALTER TABLE prodserv ADD COLUMN IF NOT EXISTS nProSrvPeso DECIMAL(12,2) DEFAULT 0.00;";
				$pdo->exec($add_column);
				echo '<br>';
				echo 'Campo nProSrvPeso agregado correctamente a la base de datos.';
				echo '<br>';

				// 1. Eliminar el procedimiento pro_listar si existe
				$dropProcedureSQL = "DROP PROCEDURE IF EXISTS pro_listar";
				$pdo->exec($dropProcedureSQL);
				echo '<br>';
				echo "Procedimiento pro_listar eliminado si existía.";
				echo '<br>';

				// 2. Crear el nuevo procedimiento almacenado pro_listar se agrego el campo ps.nProSrvPeso
				$createProcedureSQL = "
				CREATE PROCEDURE pro_listar(IN pProdServ_Id INT(11))
				BEGIN
					IF pProdServ_Id = 0 THEN
						SELECT ps.ProdServ_Id
							,ps.sProSrvCodigo
							,ps.sProSrvCodigoOriginal
							,ps.sProSrvMarca
							,ps.sProSrvNombre
							,ps.sProSrvCodigoBarras
							,ps.nProSrvFamilia_Id
							,fm.sFamDescripcion               
							,ps.Activo_Id
							,av.sActDescripcion
							,ps.nProSrvUnidad_Id
							,um.sUndDescripcion
							,ps.nProSrvExoneradoIGV
							,ps.nProSrvICBPer
							,ps.sProSrvCtaContable
							,ps.nProSrvEstado
							,ps.nProSrvEliminado
							,ps.dProSrvFecha_Act
							,ps.Usuario_Id
							,ps.sProSrvCodigo2
							,ps.sProSrvCodigoOriginal
							,ps.sProSrvMarca
							,ps.sProSrvMarcaOriginal
							,ps.nProSrvPeso
							,ifnull(sm.stock_minimo_id,0) as stock_minimo_id
						FROM prodserv ps
						INNER JOIN familia fm
						ON ps.nProSrvFamilia_Id = fm.Familia_Id 
						INNER JOIN activo av 
						ON ps.Activo_Id = av.Activo_Id 
						INNER JOIN unidadmedida um
						ON ps.nProSrvUnidad_Id = um.Unidadmedida_Id 
						LEFT JOIN stock_minimo sm
						ON ps.ProdServ_Id = sm.ProdServ_Id
						WHERE ps.nProSrvEliminado = 0 ORDER BY ps.sProSrvNombre ASC;
					ELSE
						SELECT ps.ProdServ_Id
							,ps.sProSrvCodigo
							,ps.sProSrvNombre
							,ps.sProSrvNombreComercial
							,ps.sProSrvCodigoBarras
							,ps.nProSrvFamilia_Id
							,fm.sFamDescripcion               
							,ps.Activo_Id
							,av.sActDescripcion
							,ps.nProSrvUnidad_Id
							,um.sUndDescripcion
							,ps.nProSrvExoneradoIGV
							,ps.nProSrvICBPer
							,ps.sProSrvCtaContable
							,ps.nProSrvEstado
							,ps.nProSrvEliminado
							,ps.dProSrvFecha_Act
							,ps.Usuario_Id
							,ps.ProSrvEspecificacion
							,ps.ProSrvNomImagen
							,ps.ProSrvNomImagen2
							,ps.ProSrvNomImagen3
							,ps.ProSrvNomImagen4
							,ps.sProSrvCodigo2
							,ps.sProSrvCodigoOriginal
							,ps.sProSrvMarca
							,ps.sProSrvMarcaOriginal
							,ps.nProSrvPeso
							,ifnull(sm.stock_minimo_id,0) as stock_minimo_id
						FROM prodserv ps
						INNER JOIN familia fm
						ON ps.nProSrvFamilia_Id = fm.Familia_Id 
						INNER JOIN activo av 
						ON ps.Activo_Id = av.Activo_Id 
						INNER JOIN unidadmedida um
						ON ps.nProSrvUnidad_Id = um.Unidadmedida_Id 
						LEFT JOIN stock_minimo sm
						ON ps.ProdServ_Id = sm.ProdServ_Id
						WHERE ps.ProdServ_Id = pProdServ_Id AND ps.nProSrvEliminado = 0 ORDER BY ps.sProSrvNombre ASC;
					END IF;
				END";

				// Ejecutar la consulta para crear el procedimiento
				$pdo->exec($createProcedureSQL);
				echo '<br>';
				echo "Nuevo procedimiento pro_listar creado.";
				echo '<br>';

				// Eliminar el sp pro_crear
				$delete2 = "DROP PROCEDURE IF EXISTS pro_crear;";
				$pdo->exec($delete2);
				echo '<br>';
				echo 'Procedimiento pro_crear eliminado.';
				echo '<br>';

				// Crear procedimiento pro_crear se agrego el campo psProSrvPeso
				$query2 = "
				CREATE PROCEDURE pro_crear(
						IN `psProSrvCodigo` VARCHAR(50), 
						IN `psProSrvNombre` VARCHAR(255), 
						IN `psProSrvCodigoBarras` VARCHAR(50), 
						IN `pnProSrvFamilia_Id` INT(11), 
						IN `pActivo_Id` INT(11), 
						IN `pnProSrvUnidad_Id` INT(11), 
						IN `pProSrvEspecificacion` TEXT, 
						IN `pnProSrvExoneradoIGV` TINYINT(4), 
						IN `pnProSrvICBPer` INT(11), 
						IN `psProSrvCtaContable` VARCHAR(50), 
						IN `pnProSrvEstado` TINYINT(4), 
						IN `pnProSrvEliminado` INT(11), 
						IN `pUsuario_Id` INT(11), 
						IN `psProSrvCodigo2` VARCHAR(45), 
						IN `psProSrvCodigoOriginal` VARCHAR(45), 
						IN `psProSrvMarca` VARCHAR(45), 
						IN `psProSrvNombreComercial` VARCHAR(255), 
						IN `psProSrvMarcaOriginal` VARCHAR(70), 
						IN `psProSrvPeso` DECIMAL(12,2), 
						OUT `pProdServ_Id` INT(11))
					BEGIN
						INSERT INTO prodserv (
								`sProSrvCodigo`,
								`sProSrvNombre`,
								`sProSrvCodigoBarras`,
								`nProSrvFamilia_Id`,
								`Activo_Id`,
								`nProSrvUnidad_Id`,
								`ProSrvEspecificacion`,
								`nProSrvExoneradoIGV`,
								`nProSrvICBPer`,
								`sProSrvCtaContable`,
								`nProSrvEstado`,
								`nProSrvEliminado`,
								`dProSrvFecha_Act`,
								`Usuario_Id`,			  
								`sProSrvCodigo2`,			  
								`sProSrvCodigoOriginal`,			  
								`sProSrvMarca`,
								`sProSrvNombreComercial`,
								`sProSrvMarcaOriginal`,
								`nProSrvPeso`
								) 
						VALUES (
								psProSrvCodigo,
								psProSrvNombre,
								psProSrvCodigoBarras,
								pnProSrvFamilia_Id,
								1,
								pnProSrvUnidad_Id,
								pProSrvEspecificacion,
								pnProSrvExoneradoIGV,
								pnProSrvICBPer,
								psProSrvCtaContable,
								pnProSrvEstado,
								pnProSrvEliminado,
								now(),
								pUsuario_Id,			  
								psProSrvCodigo2,			  
								psProSrvCodigoOriginal,			  
								psProSrvMarca,
								psProSrvNombreComercial,
								psProSrvMarcaOriginal,
								psProSrvPeso
								);
						SET pProdServ_Id = LAST_INSERT_ID();
						SELECT pProdServ_Id AS ProdServ_Id;
					END;";

				//ejecutar la consulta
				$pdo->exec($query2);
				echo '<br>';
				echo 'Procedimiento pro_crear creado correctamente.';
				echo '<br>';


				// eliminar el procedimiento pro_filtro
				$delete3 = "DROP PROCEDURE IF EXISTS pro_filtro;";
				$pdo->exec($delete3);
				echo '<br>';
				echo 'Prodecimiento pro_filtro eliminado';
				echo '<br>';

				// Crear procidimiento pro_filtro se agrego el campo ps.nProSrvPeso
				$query3 = "
					CREATE PROCEDURE pro_filtro(IN `psProSrvNombre` VARCHAR(50))
					NO SQL
					SELECT ps.ProdServ_Id
							,ps.sProSrvCodigo
							,ps.sProSrvNombre
							,ps.nProSrvPeso
							,ps.sProSrvCodigoBarras
							,ps.nProSrvFamilia_Id
							,fm.sFamDescripcion               
							,ps.Activo_Id
							,av.sActDescripcion
							,ps.nProSrvUnidad_Id
							,um.sUndDescripcion
							,ps.nProSrvExoneradoIGV
							,ps.nProSrvICBPer
							,ps.sProSrvCtaContable
							,ps.nProSrvEstado
							,ps.nProSrvEliminado
							,ps.dProSrvFecha_Act
							,ps.Usuario_Id
					FROM prodserv ps
					INNER JOIN familia fm
					ON ps.nProSrvFamilia_Id = fm.Familia_Id 
					INNER JOIN activo av 
					ON ps.Activo_Id = av.Activo_Id 
					INNER JOIN unidadmedida um
					ON ps.nProSrvUnidad_Id = um.Unidadmedida_Id 
					WHERE ps.nProSrvEliminado = 0 AND ps.sProSrvNombre LIKE CONCAT(''%'', psProSrvNombre, ''%'') 
					ORDER BY ps.sProSrvNombre ASC;
				";

				// Ejecutar el procedimiento
				$pdo->exec($query3);
				echo '<br>';
				echo 'Procedimiento pro_filtro creado';
				echo '<br>';

				// eliminar el sp pro_editar
				$delete4 = "DROP PROCEDURE IF EXISTS pro_editar;";
				$pdo->exec($delete4);
				echo '<br>';
				echo 'Procedimiento pro_editar eliminado';
				echo '<br>';

				// crear el procedimiento pro_editar se agrego el campo psProSrvPeso
				$query4 = "
					CREATE PROCEDURE pro_editar(
						IN `pProdServ_Id` INT(11), 
						IN `psProSrvCodigo` VARCHAR(50), 
						IN `psProSrvNombre` VARCHAR(255), 
						IN `psProSrvCodigoBarras` VARCHAR(50), 
						IN `pnProSrvFamilia_Id` INT(11), 
						IN `pActivo_Id` INT(11), 
						IN `pnProSrvUnidad_Id` INT(11), 
						IN `pProSrvEspecificacion` TEXT, 
						IN `pnProSrvExoneradoIGV` TINYINT(4), 
						IN `pnProSrvICBPer` INT(11), 
						IN `psProSrvCtaContable` VARCHAR(50), 
						IN `pnProSrvEstado` TINYINT(4), 
						IN `pnProSrvEliminado` INT(11), 
						IN `pUsuario_Id` INT(11), 
						IN `psProSrvCodigo2` VARCHAR(45), 
						IN `psProSrvCodigoOriginal` VARCHAR(45), 
						IN `psProSrvMarca` VARCHAR(45), 
						IN `psProSrvNombreComercial` VARCHAR(255), 
						IN `psProSrvMarcaOriginal` VARCHAR(70), 
						IN `psProSrvPeso` DECIMAL(12,2)
					)
					BEGIN
						UPDATE prodserv 
						SET 
							`sProSrvCodigo` = psProSrvCodigo,
							`sProSrvNombre` = psProSrvNombre,
							`sProSrvCodigoBarras` = psProSrvCodigoBarras,
							`nProSrvFamilia_Id` = pnProSrvFamilia_Id,
							`Activo_Id` = 1,
							`nProSrvUnidad_Id` = pnProSrvUnidad_Id,
							`ProSrvEspecificacion` = pProSrvEspecificacion,
							`nProSrvExoneradoIGV` = pnProSrvExoneradoIGV,
							`nProSrvICBPer` = pnProSrvICBPer,
							`sProSrvCtaContable` = psProSrvCtaContable,
							`nProSrvEstado` = pnProSrvEstado,
							`nProSrvEliminado` = pnProSrvEliminado,
							`Usuario_Id` = pUsuario_Id,
							`dProSrvFecha_Act` = NOW(),
							`sProSrvCodigo2` = psProSrvCodigo2,
							`sProSrvCodigoOriginal` = psProSrvCodigoOriginal,
							`sProSrvMarca` = psProSrvMarca,
							`sProSrvNombreComercial` = psProSrvNombreComercial,
							`sProSrvMarcaOriginal` = psProSrvMarcaOriginal,
							`nProSrvPeso` = psProSrvPeso
						WHERE `ProdServ_Id` = pProdServ_Id;
					END;
				";

				// Ejecutar el comando
				$pdo->exec($query4);
				echo '<br>';
				echo 'Procedimiento pro_editar creado correctamente';
				echo '<br>';

				// Eliminar procedimiento pro_listar2
				$delete5 = "DROP PROCEDURE IF EXISTS pro_listar2;";
				$pdo->exec($delete5);
				echo '<br>';
				echo 'Procedimiento pro_listar2 eliminado';
				echo '<br>';

				// Crear procedimiento pro_listar2 se agrego el campo ps.nProSrvPeso
				$query5 = "
					CREATE PROCEDURE pro_listar2(IN `pProdServ_Id` INT(11))
					BEGIN
						IF pProdServ_Id = 0 THEN
							SELECT ps.ProdServ_Id
								,ps.sProSrvCodigo
								,ps.sProSrvCodigoOriginal
								,ps.sProSrvMarca
								,ps.sProSrvNombre
								,ps.nProSrvPeso
								,ps.sProSrvCodigoBarras
								,ps.nProSrvFamilia_Id
								,fm.sFamDescripcion               
								,ps.Activo_Id
								,av.sActDescripcion
								,ps.nProSrvUnidad_Id
								,um.sUndDescripcion
								,ps.nProSrvExoneradoIGV
								,ps.nProSrvICBPer
								,ps.sProSrvCtaContable
								,ps.nProSrvEstado
								,ps.nProSrvEliminado
								,ps.dProSrvFecha_Act
								,ps.Usuario_Id
								,ps.sProSrvCodigo2
								,ps.sProSrvCodigoOriginal
								,ps.sProSrvMarca
								,ps.sProSrvMarcaOriginal
							FROM prodserv ps
							INNER JOIN familia fm
							ON ps.nProSrvFamilia_Id = fm.Familia_Id 
							INNER JOIN activo av 
							ON ps.Activo_Id = av.Activo_Id 
							INNER JOIN unidadmedida um
							ON ps.nProSrvUnidad_Id = um.Unidadmedida_Id 
							WHERE ps.nProSrvEliminado = 0 AND ps.nProSrvEstado = 1 
							ORDER BY ps.sProSrvNombre ASC;
						ELSE
							SELECT ps.ProdServ_Id
								,ps.sProSrvCodigo
								,ps.sProSrvNombre
								,ps.sProSrvNombreComercial
								,ps.sProSrvCodigoBarras
								,ps.nProSrvFamilia_Id
								,fm.sFamDescripcion               
								,ps.Activo_Id
								,av.sActDescripcion
								,ps.nProSrvUnidad_Id
								,um.sUndDescripcion
								,ps.nProSrvExoneradoIGV
								,ps.nProSrvICBPer
								,ps.sProSrvCtaContable
								,ps.nProSrvEstado
								,ps.nProSrvEliminado
								,ps.dProSrvFecha_Act
								,ps.Usuario_Id
								,ps.ProSrvEspecificacion
								,ps.ProSrvNomImagen
								,ps.ProSrvNomImagen2
								,ps.ProSrvNomImagen3
								,ps.ProSrvNomImagen4
								,ps.sProSrvCodigo2
								,ps.sProSrvCodigoOriginal
								,ps.sProSrvMarca
								,ps.sProSrvMarcaOriginal
								,ps.nProSrvPeso
							FROM prodserv ps
							INNER JOIN familia fm
							ON ps.nProSrvFamilia_Id = fm.Familia_Id 
							INNER JOIN activo av 
							ON ps.Activo_Id = av.Activo_Id 
							INNER JOIN unidadmedida um
							ON ps.nProSrvUnidad_Id = um.Unidadmedida_Id 
							WHERE ps.ProdServ_Id = pProdServ_Id AND ps.nProSrvEliminado = 0 AND ps.nProSrvEstado = 1
							ORDER BY ps.sProSrvNombre ASC;
						END IF;
					END;
				";

				// Ejecutar la consulta
				$pdo->exec($query5);
				echo '<br>';
				echo 'Procedimiento pro_listar2 creado correctamente';
				echo '<br>';

				//EJECUTAR EL MOVDET_LISTAR2

				
				// Eliminar procedimiento movdet_listar2 se agrego el campo p.nProSrvPeso
				$delete6 = "DROP PROCEDURE IF EXISTS movdet_listar2;";
				$pdo->exec($delete6);
				echo '<br>';
				echo 'Procedimiento movdet_listar2 eliminado';
				echo '<br>';

				//se agrego el campo p.nProSrvPeso
				$query6 = "CREATE PROCEDURE movdet_listar2(IN `pMovimiento_Id` INT(11))
						BEGIN
						DECLARE pTipoDestino tinyint;
							SET pTipoDestino = (
							SELECT nMovTipodestino FROM movimiento
							WHERE Movimiento_Id=pMovimiento_Id);
							IF pTipoDestino = 1 THEN
								SELECT md.Mmovimientodetalle_Id
									,md.Movimiento_Id
									,md.ProductoLote_Id
									,md.nMovDetUnidad_Id
									,nMovDetCantidad
									,md.nMovDetPrecioLista
									,md.nMovDetPorcDescuento1
									,md.nMovDetPorcDecuento2
									,md.nMovDetImporte
									,md.nMovDetPrecioFlete
									,md.nMovDetSaldoAnteriorLote
									,md.nMovDetSaldoPosteriorLote
									,md.nMovDetSaldoAnterior
									,md.nMovDetSaldoPosterior
									,md.nMovDetIncluyeIGV
									,md.nMovDetPrecioUnitario
									,p.prodserv_Id
									,p.sProSrvNombre
									,p.nProSrvPeso
									,p.sProSrvCodigo2
									,um.sUndalias
									,um.sUndCodeSunat
									,p.nProSrvExoneradoIGV
									,md.dMovDetICBPER
							FROM movimientodetalle md
							INNER JOIN productolote pl on (pl.productolote_Id=md.ProductoLote_Id)
							INNER JOIN prodserv p on (pl.prodserv_Id=p.prodserv_Id)
							INNER JOIn unidadmedida um on (um.unidadmedida_id=md.nMovDetUnidad_Id)
							WHERE Movimiento_Id = pMovimiento_Id;
							ELSE
							SELECT mdc.Movimientodetalleconsumo_Id
									,Movimiento_Id
									,0 as ProductoLote_Id
									,nMovDetConUnidad_Id as nMovDetUnidad_Id
									,sMovDetConCantidad as nMovDetCantidad
									,nMovDetConPrecioLista as nMovDetPrecioLista
									,nMovDetConPorcDescuento1 as nMovDetPorcDescuento1
									,0 as nMovDetPorcDecuento2
									,mdc.nMovDetConPrecioUnitario as nMovDetPrecioUnitario
									,nMovDetConImporte as nMovDetImporte
									,mdc.nMovDetConPrecioFlete as nMovDetPrecioFlete
									,0 as nMovDetSaldoAnteriorLote
									,0 as nMovDetSaldoPosteriorLote
									,0 as nMovDetSaldoAnterior
									,0 as nMovDetSaldoPosterior
									,0 as nMovDetIncluyeIGV
									,p.prodserv_Id
									,p.sProSrvNombre
									,p.nProSrvPeso
									,um.sUndalias
									,um.sUndCodeSunat
									,p.nProSrvExoneradoIGV
									,mdc.dMovDetICBPER
							FROM movimientodetalleconsumo mdc
							INNER JOIN prodserv p on (mdc.producto_Id=p.prodserv_Id)
							INNER JOIN unidadmedida um on (um.unidadmedida_id=mdc.nMovDetConUnidad_Id)
							WHERE Movimiento_Id =  pMovimiento_Id;
						END IF;
						END";

				$pdo->exec($query6);
				echo '<br>';
				echo 'Procedimiento movdet_listar2 creado correctamente';
				echo '<br>';

			// } else {
			// 	echo 'Base de datos excluida por contener _seguridad';
			// }

		// }
	
	

	} catch (PDOException $e) {
		echo "Error: " . $e->getMessage();
	}
}

?>
